QGIS Application - Bug report #17423
QGIS select by expression mismatch with MSSQL layers
2017-11-08 02:00 PM - Solution s

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/MSSQL

Affected QGIS version:2.18.14 Regression?: No

Operating System: Windows 7 Enterprise - 32 bit Easy fix?: No

Pull Request or Patch supplied: Resolution: no timely feedback
Crashes QGIS or corrupls data: Copied to github as #: 25320
Description

When trying to select features using "select by expression”, QGIS did select a wrong feature in this case.
| tried on two different days, same result (so | have restarted the PC and QGIS).
What i did was:

1. Load a layer and select it to use select by expression

2. Made sure that no features are selected in any layer

3. Clicked the select by expression button from the toolbar

4. Put in a very simple criteria: "matrikelnummer" = '10ae’

5. Clicked select/veelg (see Screenshot_1.png)

6. In Screenshot_2.png you can see which features QGIS selected in the opened attribute table. As you can see, feature with ID = 8337
(or just line 43) is selected. This should not be selected, because '10ae' |="'10an’

1. Instead it should have selected line 24 (ID = 8339), because as you can see that have '10ae’ as the "matrikelnummer"

7.1 also tried to resize the window to see if it was a graphical glitch, no luck.
Interestingly, the layer filter is able to select/filter the correct features.
What i did to further test expressions was:

1. Deselect all features

2. Opened up the layer's filter and tested the expression. Correctly returned 2 rows as you can see on Screenshot_3.png

3. Applied the filter and opened the attribute table. As you can see on Screenshot_4.png the correct features is viewed.
Some information about the layer:

- The layer is calld Hovedejer matrikel

- MSSQL spatial data provider

- srid=25832
Polygon (WKB type: "Polygon")

- (MyGeom)

- character encoding infomation not available, but since e, g, a is displayed correctly, | would guess that it's one that follows this
standard: https://en.wikipedia.org/wiki/ISO/IEC 8859-1#Similar_character_sets

- Interestingly nothing is shown in the layer properties window under "Data Source Encoding”, and I'm not able to select any option

(there is none).
- |1 think the layer is provided by a Microsoft server

History

#1 - 2017-11-08 02:07 PM - Solution s

Additional layer/field information:
The field "matrikelnummer" type is QString and typename is varchar. Max length 40, precision 0.

#2 - 2017-11-08 02:45 PM - Giovanni Manghi
- Status changed from Open to Feedback
https://en.wikipedia.org/wiki/ISO/IEC_8859-1#Similar_character_sets

Does it happens for other providers (like PostGIS) or datasources? Can you test on a more recent release? Thanks.

#3 - 2017-11-08 02:55 PM - Solution s
Works fine on this layer:
- PostgreSQL database with PostGIS extension
- key='gid'
- srid=25832
- type=MultiPolygon

I will try as soon as | get my administrator to update QGIS.

#4 - 2017-11-08 03:29 PM - Giovanni Manghi

- Status changed from Feedback to Open

- Category changed from Expressions to Data Provider/MSSQL

#5 - 2017-11-09 03:30 PM - Giovanni Manghi
- Subject changed from QGIS select by expression mismatch to QGIS select by expression mismatch with MSSQL layers

#6 - 2017-11-10 10:34 AM - Solution s

| uninstalled QGIS 2.18.11 and installed 2.18.14.

| can reproduce the issue on 2.18.14.

#7 - 2017-11-13 11:00 AM - Giovanni Manghi

- Affected QGIS version changed from 2.18.11 to 2.18.14

#8 - 2018-10-02 10:37 PM - Nyall Dawson

- Status changed from Open to Feedback

Can you provide a SQL dump of part of this layer?

#9 - 2019-01-21 12:34 AM - Jiirgen Fischer

Please test with QGIS 3.4 - QGIS 2.18 reached it's end of life.

#10 - 2019-02-24 10:51 AM - Giovanni Manghi

- Resolution set to no timely feedback
- Status changed from Feedback to Closed
